use std::error::Error;

use ldap3::{LdapConn, Scope, SearchEntry};

pub fn do_search(host: &str, port: u16, base: &str) -> Result<(), Box<Error>> {
  let conn_string = format!("ldap://{}:{}", host, port);

  let ldap = LdapConn::new(&conn_string)?;
  let (rs, _res) = ldap.search(
    base,
    Scope::Subtree,
    "(&(objectClass=*))",
    vec!["l"]
  )?.success()?;

  for entry in rs {
    println!("{:?}", SearchEntry::construct(entry));
  }

  Ok(())
}
